package org.openqa.selenium.devtools.v104.audits.model;

import org.openqa.selenium.Beta;
import org.openqa.selenium.json.JsonInput;

/**
 * This struct holds a list of optional fields with additional information
 * specific to the kind of issue. When adding a new issue code, please also
 * add a new optional field to this type.
 */
public class InspectorIssueDetails {

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CookieIssueDetails> cookieIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.MixedContentIssueDetails> mixedContentIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ContentSecurityPolicyIssueDetails> contentSecurityPolicyIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.SharedArrayBufferIssueDetails> sharedArrayBufferIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.TrustedWebActivityIssueDetails> twaQualityEnforcementDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.LowTextContrastIssueDetails> lowTextContrastIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CorsIssueDetails> corsIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.AttributionReportingIssueDetails> attributionReportingIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.QuirksModeIssueDetails> quirksModeIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.NavigatorUserAgentIssueDetails> navigatorUserAgentIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.GenericIssueDetails> genericIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.DeprecationIssueDetails> deprecationIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ClientHintIssueDetails> clientHintIssueDetails;

    private final java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.FederatedAuthRequestIssueDetails> federatedAuthRequestIssueDetails;

    public InspectorIssueDetails(java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CookieIssueDetails> cookieIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.MixedContentIssueDetails> mixedContentIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ContentSecurityPolicyIssueDetails> contentSecurityPolicyIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.SharedArrayBufferIssueDetails> sharedArrayBufferIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.TrustedWebActivityIssueDetails> twaQualityEnforcementDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.LowTextContrastIssueDetails> lowTextContrastIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CorsIssueDetails> corsIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.AttributionReportingIssueDetails> attributionReportingIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.QuirksModeIssueDetails> quirksModeIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.NavigatorUserAgentIssueDetails> navigatorUserAgentIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.GenericIssueDetails> genericIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.DeprecationIssueDetails> deprecationIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ClientHintIssueDetails> clientHintIssueDetails, java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.FederatedAuthRequestIssueDetails> federatedAuthRequestIssueDetails) {
        this.cookieIssueDetails = cookieIssueDetails;
        this.mixedContentIssueDetails = mixedContentIssueDetails;
        this.blockedByResponseIssueDetails = blockedByResponseIssueDetails;
        this.heavyAdIssueDetails = heavyAdIssueDetails;
        this.contentSecurityPolicyIssueDetails = contentSecurityPolicyIssueDetails;
        this.sharedArrayBufferIssueDetails = sharedArrayBufferIssueDetails;
        this.twaQualityEnforcementDetails = twaQualityEnforcementDetails;
        this.lowTextContrastIssueDetails = lowTextContrastIssueDetails;
        this.corsIssueDetails = corsIssueDetails;
        this.attributionReportingIssueDetails = attributionReportingIssueDetails;
        this.quirksModeIssueDetails = quirksModeIssueDetails;
        this.navigatorUserAgentIssueDetails = navigatorUserAgentIssueDetails;
        this.genericIssueDetails = genericIssueDetails;
        this.deprecationIssueDetails = deprecationIssueDetails;
        this.clientHintIssueDetails = clientHintIssueDetails;
        this.federatedAuthRequestIssueDetails = federatedAuthRequestIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CookieIssueDetails> getCookieIssueDetails() {
        return cookieIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.MixedContentIssueDetails> getMixedContentIssueDetails() {
        return mixedContentIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.BlockedByResponseIssueDetails> getBlockedByResponseIssueDetails() {
        return blockedByResponseIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.HeavyAdIssueDetails> getHeavyAdIssueDetails() {
        return heavyAdIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ContentSecurityPolicyIssueDetails> getContentSecurityPolicyIssueDetails() {
        return contentSecurityPolicyIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.SharedArrayBufferIssueDetails> getSharedArrayBufferIssueDetails() {
        return sharedArrayBufferIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.TrustedWebActivityIssueDetails> getTwaQualityEnforcementDetails() {
        return twaQualityEnforcementDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.LowTextContrastIssueDetails> getLowTextContrastIssueDetails() {
        return lowTextContrastIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CorsIssueDetails> getCorsIssueDetails() {
        return corsIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.AttributionReportingIssueDetails> getAttributionReportingIssueDetails() {
        return attributionReportingIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.QuirksModeIssueDetails> getQuirksModeIssueDetails() {
        return quirksModeIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.NavigatorUserAgentIssueDetails> getNavigatorUserAgentIssueDetails() {
        return navigatorUserAgentIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.GenericIssueDetails> getGenericIssueDetails() {
        return genericIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.DeprecationIssueDetails> getDeprecationIssueDetails() {
        return deprecationIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ClientHintIssueDetails> getClientHintIssueDetails() {
        return clientHintIssueDetails;
    }

    public java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.FederatedAuthRequestIssueDetails> getFederatedAuthRequestIssueDetails() {
        return federatedAuthRequestIssueDetails;
    }

    private static InspectorIssueDetails fromJson(JsonInput input) {
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CookieIssueDetails> cookieIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.MixedContentIssueDetails> mixedContentIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.BlockedByResponseIssueDetails> blockedByResponseIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.HeavyAdIssueDetails> heavyAdIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ContentSecurityPolicyIssueDetails> contentSecurityPolicyIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.SharedArrayBufferIssueDetails> sharedArrayBufferIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.TrustedWebActivityIssueDetails> twaQualityEnforcementDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.LowTextContrastIssueDetails> lowTextContrastIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.CorsIssueDetails> corsIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.AttributionReportingIssueDetails> attributionReportingIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.QuirksModeIssueDetails> quirksModeIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.NavigatorUserAgentIssueDetails> navigatorUserAgentIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.GenericIssueDetails> genericIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.DeprecationIssueDetails> deprecationIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.ClientHintIssueDetails> clientHintIssueDetails = java.util.Optional.empty();
        java.util.Optional<org.openqa.selenium.devtools.v104.audits.model.FederatedAuthRequestIssueDetails> federatedAuthRequestIssueDetails = java.util.Optional.empty();
        input.beginObject();
        while (input.hasNext()) {
            switch(input.nextName()) {
                case "cookieIssueDetails":
                    cookieIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.CookieIssueDetails.class));
                    break;
                case "mixedContentIssueDetails":
                    mixedContentIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.MixedContentIssueDetails.class));
                    break;
                case "blockedByResponseIssueDetails":
                    blockedByResponseIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.BlockedByResponseIssueDetails.class));
                    break;
                case "heavyAdIssueDetails":
                    heavyAdIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.HeavyAdIssueDetails.class));
                    break;
                case "contentSecurityPolicyIssueDetails":
                    contentSecurityPolicyIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.ContentSecurityPolicyIssueDetails.class));
                    break;
                case "sharedArrayBufferIssueDetails":
                    sharedArrayBufferIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.SharedArrayBufferIssueDetails.class));
                    break;
                case "twaQualityEnforcementDetails":
                    twaQualityEnforcementDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.TrustedWebActivityIssueDetails.class));
                    break;
                case "lowTextContrastIssueDetails":
                    lowTextContrastIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.LowTextContrastIssueDetails.class));
                    break;
                case "corsIssueDetails":
                    corsIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.CorsIssueDetails.class));
                    break;
                case "attributionReportingIssueDetails":
                    attributionReportingIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.AttributionReportingIssueDetails.class));
                    break;
                case "quirksModeIssueDetails":
                    quirksModeIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.QuirksModeIssueDetails.class));
                    break;
                case "navigatorUserAgentIssueDetails":
                    navigatorUserAgentIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.NavigatorUserAgentIssueDetails.class));
                    break;
                case "genericIssueDetails":
                    genericIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.GenericIssueDetails.class));
                    break;
                case "deprecationIssueDetails":
                    deprecationIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.DeprecationIssueDetails.class));
                    break;
                case "clientHintIssueDetails":
                    clientHintIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.ClientHintIssueDetails.class));
                    break;
                case "federatedAuthRequestIssueDetails":
                    federatedAuthRequestIssueDetails = java.util.Optional.ofNullable(input.read(org.openqa.selenium.devtools.v104.audits.model.FederatedAuthRequestIssueDetails.class));
                    break;
                default:
                    input.skipValue();
                    break;
            }
        }
        input.endObject();
        return new InspectorIssueDetails(cookieIssueDetails, mixedContentIssueDetails, blockedByResponseIssueDetails, heavyAdIssueDetails, contentSecurityPolicyIssueDetails, sharedArrayBufferIssueDetails, twaQualityEnforcementDetails, lowTextContrastIssueDetails, corsIssueDetails, attributionReportingIssueDetails, quirksModeIssueDetails, navigatorUserAgentIssueDetails, genericIssueDetails, deprecationIssueDetails, clientHintIssueDetails, federatedAuthRequestIssueDetails);
    }
}
